
-------------------------------------------------------------------------------
-- Optimization
-------------------------------------------------------------------------------

-- GLOBALS: BuffButtonMixin, CreateFrame, DebuffButtonMixin, DebuffFrame, next

local BuffFrame = BuffFrame
local GetWeaponEnchantInfo = GetWeaponEnchantInfo
local select = select
local UnitAura = UnitAura

-------------------------------------------------------------------------------
-- Namespace
-------------------------------------------------------------------------------

local A, B, C, D = unpack(select(2, ...)) -- AddOn, Border, Constants, Database
local M = A:NewModule("Buff Bars")

-------------------------------------------------------------------------------
-- Module
-------------------------------------------------------------------------------

-- Contributed by https://wow.tools/dbc/?dbc=spellitemenchantment&build=10.0.5.47660#page=1.
M.EnchantDuration = setmetatable({
    [13] = 3600, -- Sharpened II
    [14] = 3600, -- Sharpened III
    [19] = 3600, -- Weighted I
    [20] = 3600, -- Weighted II
    [21] = 3600, -- Weighted III
    [25] = 1800, -- Shadow Oil
    [26] = 1800, -- Frost Oil
    [38] = 3600, -- +$k1 Dodge
    [40] = 3600, -- Sharpened I
    [64] = 3600, -- +$k1 Versatility
    [244] = 3600, -- +$k1 Intellect
    [245] = 3600, -- +$k1 Armor
    [252] = 3600, -- +$k1 Versatility
    [253] = 3600, -- Absorption ($7848s1)
    [257] = 3600, -- +$k1 Armor
    [263] = 600, -- Fishing Lure (+$8082s1 Fishing Skill)
    [264] = 600, -- Fishing Lure (+$8083s1 Fishing Skill)
    [265] = 600, -- Fishing Lure (+$8084s1 Fishing Skill)
    [266] = 600, -- Fishing Lure (+$8085s1 Fishing Skill)
    [483] = 3600, -- Sharpened IV
    [484] = 3600, -- Weighted IV
    [1003] = 300, -- Venomhide Poison
    [1643] = 3600, -- Sharpened V
    [1703] = 3600, -- Weighted V
    [1723] = 300, -- Omen of Clarity
    [1803] = 10, -- Firestone 1
    [1823] = 10, -- Firestone 2
    [1824] = 10, -- Firestone 3
    [1825] = 10, -- Firestone 4
    [2506] = 3600, -- +$k1 Melee Critical Strike
    [2623] = 3600, -- Minor Wizard Oil
    [2624] = 3600, -- Minor Mana Oil
    [2625] = 3600, -- Lesser Mana Oil
    [2626] = 3600, -- Lesser Wizard Oil
    [2627] = 3600, -- Wizard Oil
    [2628] = 3600, -- Brilliant Wizard Oil
    [2629] = 3600, -- Brilliant Mana Oil
    [2645] = 1, -- Firestone 5
    [2676] = 3600, -- Superior Mana Oil
    [2677] = 3600, -- Superior Mana Oil
    [2678] = 3600, -- Superior Wizard Oil
    [2684] = 3600, -- 100 Attack Power vs Undead
    [2712] = 3600, -- Sharpened VI
    [2713] = 3600, -- Sharpened VII
    [2718] = 3600, -- Lesser Rune of Warding
    [2719] = 3600, -- Lesser Ward of Shielding
    [2790] = 120, -- ZZOLDLesser Rune of Warding
    [2791] = 3600, -- Greater Rune of Warding
    [2795] = 1800, -- Comfortable Insoles
    [2954] = 3600, -- Weighted VI
    [2955] = 3600, -- Weighted VII
    [3093] = 300, -- +$37362s1 Attack Power vs Undead and Demons
    [3102] = 1800, -- Poison
    [3265] = 3600, -- Blessed Weapon Coating
    [3266] = 3600, -- Righteous Weapon Coating
    [3279] = 3600, -- +$k1 Spell Power
    [3298] = 3600, -- Exceptional Mana Oil
    [3299] = 3600, -- Exceptional Wizard Oil
    [3322] = 1800, -- Frozen Rune Weapon
    [3341] = 1800, -- Frozen Rune Weapon 2
    [3342] = 1800, -- Frozen Rune Weapon 3
    [3343] = 1800, -- Frozen Rune Weapon 4
    [3344] = 1800, -- Frozen Rune Weapon 5
    [3592] = 3600, -- +$54288s1 Spell Power vs Undead
    [3593] = 3600, -- +$54289s1 Attack Power vs Undead
    [3597] = 3600, -- Master Firestone
    [3609] = 3600, -- Firestone
    [3610] = 3600, -- Firestone
    [3611] = 3600, -- Greater Firestone
    [3612] = 3600, -- Major Firestone
    [3613] = 3600, -- Fel Firestone
    [3614] = 3600, -- Grand Firestone
    [3615] = 3600, -- Spellstone
    [3616] = 3600, -- Greater Spellstone
    [3617] = 3600, -- Major Spellstone
    [3618] = 3600, -- Master Spellstone
    [3619] = 3600, -- Demonic Spellstone
    [3620] = 3600, -- Grand Spellstone
    [3868] = 3600, -- Fishing Lure (+$8085s1 Fishing Skill)
    [4225] = 900, -- Fishing Lure (+$95243s1 Fishing Skill)
    [4264] = 600, -- Fishing Lure (+$7825s1 Fishing Skill)
    [4891] = 3600, -- Pandaren Fishing Lure
    [4919] = 600, -- Fishing Lure (+$128586s1 Fishing Skill)
    [5270] = 3600, -- Living Clay Weapon
    [5332] = 3600, -- Frostbrand Visual Only
    [5386] = 600, -- Fishing Lure (+$174472s1 Fishing Skill)
    [5398] = 3600, -- Earthliving
    [5399] = 3600, -- Frostbrand
    [5400] = 3600, -- Flametongue
    [5401] = 3600, -- Windfury
    [5402] = 3600, -- Rockbiter
    [5450] = 300, -- Rockbiter
    [6188] = 3600, -- Shadowcore Oil
    [6190] = 3600, -- Embalmer's Oil
    [6198] = 3600, -- Sharpened VIII
    [6199] = 3600, -- Weighted VIII
    [6200] = 3600, -- Sharpened IX
    [6201] = 3600, -- Weighted IX
    [6224] = 7200, -- Reinforced (+$k1 Stamina)
    [6225] = 7200, -- Reinforced (+$k1 Stamina)
    [6252] = 7200, -- Reinforced (+$k1 Stamina)
    [6379] = 7200, -- Sharpened: +$k1 Attack Power |A:Professions-Icon-Quality-Tier1-Small:20:20|a
    [6380] = 7200, -- Sharpened: +$k1 Attack Power |A:Professions-Icon-Quality-Tier2-Small:20:20|a
    [6381] = 7200, -- Sharpened: +$k1 Attack Power |A:Professions-Icon-Quality-Tier3-Small:20:20|a
    [6382] = 7200, -- Razor Sharp: +$k1 Finesse |A:Professions-Icon-Quality-Tier1-Small:20:20|a
    [6383] = 7200, -- Razor Sharp: +$k1 Finesse |A:Professions-Icon-Quality-Tier2-Small:20:20|a
    [6384] = 7200, -- Razor Sharp: +$k1 Finesse |A:Professions-Icon-Quality-Tier3-Small:20:20|a
    [6498] = 3600, -- Earthliving
    [6511] = 3600, -- Padded
    [6512] = 7200, -- Buzzing Rune
    [6513] = 7200, -- Buzzing Rune
    [6514] = 7200, -- Buzzing Rune
    [6515] = 7200, -- Chirping Rune
    [6516] = 7200, -- Howling Rune
    [6517] = 7200, -- Howling Rune
    [6518] = 7200, -- Howling Rune
    [6529] = 3600, -- Completely Safe Rockets |A:Professions-Icon-Quality-Tier1-Small:20:20|a
    [6530] = 3600, -- Completely Safe Rockets |A:Professions-Icon-Quality-Tier2-Small:20:20|a
    [6531] = 3600, -- Completely Safe Rockets |A:Professions-Icon-Quality-Tier3-Small:20:20|a
    [6532] = 3600, -- Endless Stack of Needles |A:Professions-Icon-Quality-Tier1-Small:20:20|a
    [6533] = 3600, -- Endless Stack of Needles |A:Professions-Icon-Quality-Tier2-Small:20:20|a
    [6534] = 3600, -- Endless Stack of Needles |A:Professions-Icon-Quality-Tier3-Small:20:20|a
    [6671] = 1200, -- Illusory Adornment: Fire
    [6673] = 2400, -- Illusory Adornment: Fire
    [6674] = 3600, -- Illusory Adornment: Fire
    [6679] = 1200, -- Illusory Adornment: Frost
    [6680] = 2400, -- Illusory Adornment: Frost
    [6681] = 3600, -- Illusory Adornment: Frost
    [6682] = 1200, -- Illusory Adornment: Air
    [6683] = 2400, -- Illusory Adornment: Air
    [6684] = 3600, -- Illusory Adornment: Air
    [6685] = 1200, -- Illusory Adornment: Earth
    [6686] = 2400, -- Illusory Adornment: Earth
    [6687] = 3600, -- Illusory Adornment: Earth
    [6688] = 1200, -- Illusory Adornment: Order
    [6689] = 2400, -- Illusory Adornment: Order
    [6690] = 3600, -- Illusory Adornment: Order
    [6694] = 7200, -- Chirping Rune
    [6695] = 7200, -- Chirping Rune
    [6696] = 7200, -- Weighted: +$k1 Attack Power |A:Professions-Icon-Quality-Tier1-Small:20:20|a
    [6697] = 7200, -- Weighted: +$k1 Attack Power |A:Professions-Icon-Quality-Tier2-Small:20:20|a
    [6698] = 7200, -- Weighted: +$k1 Attack Power |A:Professions-Icon-Quality-Tier3-Small:20:20|a
}, {
	__index = function (t, k) return 3600 end,
})

function M.GetAuraDuration(aura, filter)
	if aura.buttonInfo.isTempEnchant then
		return M.EnchantDuration[M.GetEnchantID(aura)]
	else
		return select(5, UnitAura(aura.unit, aura.buttonInfo.index, filter))
	end
end

function M.GetEnchantID(aura)
	return select(aura.buttonInfo.ID == 16 and 4 or 8, GetWeaponEnchantInfo())
end

function M.IsAuraValid(aura)
	return aura and aura.buttonInfo and ((aura.buttonInfo.isTempEnchant and aura.buttonInfo.ID) or (aura.buttonInfo.index and aura.unit))
end

function M:OnEnable()
	if not self:IsHooked(BuffFrame, "UpdateAuraButtons") then
		self:SecureHook(BuffFrame, "UpdateAuraButtons", "CreateHelpfulBars")
	end

	if not self:IsHooked(BuffFrame, "UpdateGridLayout") then
		self:SecureHook(BuffFrame, "UpdateGridLayout", "CreateHelpfulBars")
	end

	if not self:IsHooked(DebuffFrame, "UpdateAuraButtons") then
		self:SecureHook(DebuffFrame, "UpdateAuraButtons", "CreateHarmfulBars")
	end

	if not self:IsHooked(DebuffFrame, "UpdateGridLayout") then
		self:SecureHook(DebuffFrame, "UpdateGridLayout", "CreateHarmfulBars")
	end

	self:RegisterMessage("SIXUI_CLUTTER_STATE_CHANGED")
	self:CreateBars()
end

function M:OnDisable()
	self:CreateBars()
end

function M:CreateBars()
	self:CreateHarmfulBars()
	self:CreateHelpfulBars()
end

function M:CreateHarmfulBars()
	for _, aura in next, DebuffFrame.auraFrames do
		self:CreateBar(aura, "HARMFUL")
	end
end

function M:CreateHelpfulBars()
	for _, aura in next, BuffFrame.auraFrames do
		self:CreateBar(aura, "HELPFUL")
	end
end

function M:CreateBar(aura, filter)
	if not self.IsAuraValid(aura) then return end
	local bar = aura.bar or CreateFrame("StatusBar", nil, aura, "SixUI_BuffBarTemplate")
	local color = filter == "HARMFUL" and C.DEBUFF_TYPE_TO_COLOR[aura.buttonInfo.debuffType] or C.PLAYER_COLOR
	local duration = self.GetAuraDuration(aura, filter)
	local hidden = not aura.timeLeft or not duration or M.config.enabled == false or M.isClutterKeyDown

	aura.Duration:SetAlpha(hidden and 1 or 0)
	bar:SetShown(not hidden)

	if not hidden then
		bar:SetMinMaxValues(0, duration)
		bar:SetStatusBarColor(color.r, color.g, color.b)

		if filter == "HARMFUL" then
			bar:GetBorder():SetColor(color.r, color.g, color.b)
		end
	end
end

-------------------------------------------------------------------------------
-- Events
-------------------------------------------------------------------------------

function M:SIXUI_CLUTTER_STATE_CHANGED(event, state)
	self.isClutterKeyDown = state
	self:CreateBars()
end
